% These codes are written by Prof. Jayanta Mukherjee, IIT Kharagpur
% during his visit to Univ. of Southern California during July'2007 to 
% Dec.'2007. The codes may be used freely for any academic and research 
% purpose. 

function Y =enhance_composite_dyn_sigma(C,gamma,maxDC,k)
% Use of ynamic range compression as described in "An efficient
% content-based image enhancement in the compressed domain using retinex
% theory", by Sangkuen Lee, IEEE CSVT, vo. 17, no.2, pp.199-213,Feb. 2007
%combined with scaling and chromatic scaling (by JM)


[h w d]=size(C);

 Y=C;
 X=C(:,:,1);
 U=C(:,:,2);
 V=C(:,:,3);
 enh_X=X;
 
  xdc=X(1,1)/8;
 
variance=0;
for i=1:8
    for j=1:8
        variance=variance+(X(i,j)*X(i,j))/64;
    end
end

variance=variance-xdc*xdc;
sigma=sqrt(variance);


 nxdc=xdc/maxDC;
 enxdc=(nxdc^(1/gamma)+(1-(1-nxdc)^(1/gamma)))/2;

 exdc=enxdc*maxDC;
  
  factor=exdc/xdc;
  
  if(factor>255/(xdc+k*sigma))
   
     factor=255/(xdc+k*sigma);
  end
 if(factor<1)
     factor=1;
 end
 

 udc=U(1,1)/8-128;
 vdc=V(1,1)/8-128;
 eudc=factor*udc+128;
 evdc=factor*vdc+128;
 U=factor*U;
 V=factor*V;
   U(1,1)=eudc*8;
   V(1,1)=evdc*8;

   
   
   
 Y(:,:,1)=  factor*X;
 Y(:,:,2)=U;
 Y(:,:,3)=V;

  return